let solve dx dy shops queries = 
  let s = dx+dy-1 in
  let trans (x,y) = (x+y-2, -x+y+dx-1) in

  let sh = Array.make_matrix s s false in
  let col = Array.make_matrix s s 0 in
  let sum = Array.make_matrix s s 0 in

  let access a h v = 
    if h<0 || v<0 then 0 else
      let (h,v) = (min h (s-1), min v (s-1)) in
	a.(h).(v)
  in

  let _ = 
    List.iter (fun e -> let (h,v) = trans e in sh.(h).(v) <- true) shops;

    for i=0 to s-1 do for j=0 to s-1 do
      col.(i).(j) <- (access col i (j-1)) + (if sh.(i).(j) then 1 else 0);
      sum.(i).(j) <- (access sum (i-1) j) + (access col i j)
    done done;
  in

  let search r = 
    let next (x,y) = if x<dx then (x+1,y) else (1,y+1) in
    let rec scan pt m best = 
      if pt = (1,dy+1) then (m,best) else
	let (h,v) = trans pt in
	let count = 
	  (access sum (h+r) (v+r)) 
	  - (access sum (h-r-1) (v+r)) 
	  - (access sum (h+r) (v-r-1)) 
	  + (access sum (h-r-1) (v-r-1))
	in
	  if count > m then scan (next pt) count pt else scan (next pt) m best
    in
      scan (1,1) (-1) (1,1)
  in  
    List.rev_map search queries
    
let read_int () = 
  Scanf.bscanf Scanf.Scanning.stdib " %d " (fun x -> x)

let rec solve_rest case = 
  let dx = read_int() in
  let dy = read_int() in
  let n = read_int() in
  let q = read_int() in
    if dx*dx + dy*dy + n*n + q*q > 0 then
      let rec loopc i accum = 
	if i=n then accum else 
	  let x = read_int() in
	  let y = read_int() in
	    loopc (i+1) ((x,y)::accum)
      in
      let shops = loopc 0 [] in

      let rec loopq i accum =
	if i=q then accum else loopq (i+1) ((read_int())::accum) 
      in
      let queries = loopq 0 [] in
	Printf.printf "Case %d:\n" case;
	List.iter (
	  fun (count,(x,y)) -> Printf.printf "%d (%d,%d)\n" count x y
	) (solve dx dy shops queries);
	solve_rest (case+1)
;;

solve_rest 1
